//**************************************************************************************************
//*  FRIDA: fast reliable interactive data analysis
//*  (C) Joachim Wuttke 1990-, v2(C++) 2001-
//*  http://apps.jcns.fz-juelich.de/frida
//**************************************************************************************************

//! \file  fsel.hpp
//! \brief Declare online file selection

#include "registry.hpp"

//! Online memory and the default file selection.

class SFSel : public triv::ISingleton<SFSel> {
private:
    vector<int> FSel, FSelOld, FSelNew;
    void sel_push( const vector<int>& _FSel );
public:
    // Read file selection:
    const vector<int>& sel() const;
    vector<int> selD() const;
    vector<int> selC() const;
    COlo* sel_first() const;
    int nJ_max() const;

    // Modify file selection:
    void sel_delete();
    void sel_push_back( int k );
    void set_selection( RObjVecInt _sel );
    void sel_collect_begin();
    void sel_collect_end();
    void sel_increment( int step );
};
