//**************************************************************************************************
//*  FRIDA: fast reliable interactive data analysis
//*  (C) Joachim Wuttke 1990-, v2(C++) 2001-
//*  http://apps.jcns.fz-juelich.de/frida
//**************************************************************************************************

//! \file  loop.hpp
//! \brief Declares iterator over file selection.


//! Iterate over all files in selection.

class FileIterator {
private:
    int iV;
    vector<int> Sel;
public:
    FileIterator( const vector<int>& _Sel, bool tolerate_empty=false );
    void reset() { iV = 0; }
    int k() const { return Sel[iV-1]; }
    int iteration() const { return iV-1; }
    int size() const { return Sel.size(); }
    // return current file, and advance iterator:
    COlo* next();
    COld* nextD();
    COlc* nextC();
};
