//**************************************************************************************************
//* libtrivia: various little routines for C++
//* vector_ops: vector operations
//* (C) Joachim Wuttke 2001, 2012-
//* http://apps.jcns.fz-juelich.de
//**************************************************************************************************

namespace triv {

    void insert_in_sorted( std::vector<double> *V, double val );
    void make_unique( std::vector<double> *V, double tolabs=1e-100, double tolrel=1e-10 );
    bool is_ascending( const std::vector<double>& V );
    bool is_equidist( double *step, const std::vector<double>& V );
    std::vector<size_t> sorted_indices( std::vector<double> const& V );
    vector<int> iota_list( int number_of_entries );

    void increment_indices( std::vector<int>& v, int incr, int siz );
    std::string indices_to_s( const std::vector<int>& v );

    template<class A>
    bool contains( const std::vector<A>& v, const A e )
    { return std::find( v.begin(), v.end(), e ) != v.end(); }
}
