//***************************************************************************//
//* libtrivia: various little routines for C++                              *//
//* yaml_out: workaround for YAML output                                    *//
//* (C) Joachim Wuttke 2001, 2012-                                          *//
//* http://apps.jcns.fz-juelich.de                                          *//
//***************************************************************************//

#include <string>
#include "yaml_out.hpp"
using namespace std;

//! Wrap string for yaml output.

string triv::yaml( const string s )
{
    if ( s=="" )
        return "\"\"";
    string out = s;
    size_t i = 0;
    // escape "
    while( i < out.size() ){
        if( ( out[i]=='"' || out[i]=='\'' ) && (i==0 || out[i-1]!='\\') )
            out.insert( i, "\\" );
        ++i;
    }
    // if there are special characters, put "" around
    if( s.find( '"' )!=string::npos ||
        s.find( '\'' )!=string::npos ||
        s.find( '\\' )!=string::npos ||
        s.find( '-' )!=string::npos ||
        s.find( ':' )!=string::npos ||
        s.find( '*' )!=string::npos ||
        s.find( '&' )!=string::npos ||
        s.find( '#' )!=string::npos ||
        s.find( '>' )!=string::npos ||
        s.find( '<' )!=string::npos ||
        s.find( '[' )!=string::npos ||
        s.find( ']' )!=string::npos ||
        s.find( '{' )!=string::npos ||
        s.find( '}' )!=string::npos
        )
        out = '"' + out + '"';
    return out;
}

